package view 
{
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	/**
	 * LEDボタンクラス
	 * @author nomura masayuki
	 */
	public class LightBtn extends MovieClip
	{
		private var _on:Boolean = false; // カレント状態
		public static const LIGHT_CHANGE:String = "view.LightBtin.LIGHT_CHANGE";
		
		/**
		 * コンストラクタ
		 */
		public function LightBtn() 
		{
			if (stage)
				f_init();
			else
				addEventListener(Event.ADDED_TO_STAGE, f_init);								 
		}
		
		/**
		 * 初期化処理
		 * @param	p_ev
		 */
		private function f_init(p_ev:Event = null):void
		{
			if (p_ev) removeEventListener(Event.ADDED_TO_STAGE, f_init);
			
			mouseChildren = false;
			mouseEnabled = true;
			useHandCursor = true;
			
			addEventListener(MouseEvent.CLICK, clickHandler);
		}
		
		/**
		 * クリックハンドラ
		 * @param	p_ev
		 */
		private function clickHandler(p_ev:MouseEvent):void
		{
			if (on)
				reset();
			else
				setOn();
			
			dispatchEvent(new Event(LIGHT_CHANGE));
		}
		
		/**
		 * カレント状態
		 */
		public function get on():Boolean { return _on; }
		
		/**
		 * カレントに設定
		 */
		public function setOn():void
		{
			gotoAndStop("on");
			_on = true;
		}
		
		/**
		 * 非カレントに設定
		 */
		public function reset():void
		{
			gotoAndStop("off");
			_on = false;
		}
	}

}