package view 
{
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	/**
	 * ステップボタンクラス
	 * @author nomura masayuki
	 */
	public class StepBtn extends MovieClip
	{
		private var _step:uint = 0; // 対応するステップ番号
		public static const STEP_CLICK:String = "view.StepBtn.STEP_CLICK";
		
		/**
		 * コンストラクタ
		 * @param	step 対応するステップ番号
		 */
		public function StepBtn(step:uint = 0) 
		{
			_step = step;
			if (stage)
				f_init();
			else
				addEventListener(Event.ADDED_TO_STAGE, f_init);								 
		}
		
		/**
		 * 初期化処理
		 * @param	p_ev
		 */
		private function f_init(p_ev:Event = null):void
		{
			if (p_ev) removeEventListener(Event.ADDED_TO_STAGE, f_init);
			
			mouseChildren = false;
			mouseEnabled = true;
			useHandCursor = true;
			enabled = true;
			
			addEventListener(MouseEvent.CLICK, clickHandler);
		}
		
		/**
		 * クリックハンドラ
		 * @param	p_ev
		 */
		private function clickHandler(p_ev:MouseEvent):void
		{
			dispatchEvent(new Event(STEP_CLICK));
		}
		
		/**
		 * カレントに設定
		 */
		public function setCurrent():void
		{
			gotoAndStop("on");
			enabled = false;
		}
		
		/**
		 * 非カレントに設定
		 */
		public function reset():void
		{
			gotoAndStop("off");
			enabled = true;
		}
		
		/**
		 * 対応するステップ番号
		 */
		public function get step():uint { return _step; }
		
	}

}